var page = 100;
var subPage = "01";
window.onload = onload;

function RSchange()
{
    if(xmlhttp.readyState == 4)
    {
        if(xmlhttp.status == 200)
        {
            document.getElementById('teletekst').src = url; //OK
            SubAvailable(page, GetSubPage(subPage, true));
        }
        else if(xmlhttp.status == 404)
        {
            document.getElementById('teletekst').src = "http://teletekst.nos.nl/images/page_na1.gif"; //Not found
            genericButtonSetEnabled(btnPreviousSub, false);
            genericButtonSetEnabled(btnNextSub, false);
        }
        else document.getElementById('content').innerHTML = "Status: " + xmlhttp.status + " " + xmlhttp.statusText + " op " + url; //Other
    }
}

function RSchangeUp()
{
    if(xmlhttp.readyState == 4)
    {
        if(xmlhttp.status == 200)
        {
            document.getElementById('teletekst').src = url; //OK
            SubAvailable(page, "02");
        }
        else if(xmlhttp.status == 404)
        {
            if(page < 899) page++;
            else page = 100;
            Go(page, "01", RSchangeUp);
        }
        else document.getElementById('content').innerHTML = "Status: " + xmlhttp.status + " " + xmlhttp.statusText + " op " + url; //Other
    }
}

function RSchangeDown()
{
    if(xmlhttp.readyState == 4)
    {
        if(xmlhttp.status == 200)
        {
            document.getElementById('teletekst').src = url; //OK
            SubAvailable(page, "02");
        }
        else if(xmlhttp.status == 404)
        {
            if(page > 100) page--;
            else page = 899;
            Go(page, "01", RSchangeDown);
        }
        else document.getElementById('content').innerHTML = "Status: " + xmlhttp.status + " " + xmlhttp.statusText + " op " + url; //Other
    }
}

function RSchangeSubPageTester()
{
    if(xmlhttp.readyState == 4)
    {
        if(xmlhttp.status == 200) genericButtonSetEnabled(btnNextSub, true);
        else if(xmlhttp.status == 404) genericButtonSetEnabled(btnNextSub, false);
        else document.getElementById('content').innerHTML = "Status: " + xmlhttp.status + " " + xmlhttp.statusText + " op " + url; //Other
    }
}

function Go(pagina, sub, rsChangeFunction)
{
    document.getElementById('content').innerHTML = "";
    xmlhttp = new XMLHttpRequest();
    if(xmlhttp)
    {
        if(sub == "") sub = "01";
        else if(sub.length == 1) sub = "0" + sub;

        document.getElementById('sub').value = sub;
        document.getElementById('pagina').value = pagina;
        document.getElementById('pagina').focus();
        document.getElementById('pagina').select();

        url = "http://teletekst.nos.nl/gif/images/" + pagina + "-" + sub + ".gif?" + (new Date).getTime(); //we need this because of some kind of caching issue with Dashboard
        xmlhttp.open("GET", url, true);
        xmlhttp.onreadystatechange = rsChangeFunction;
        xmlhttp.send(null);
    }
}

function SubAvailable(pagina, sub)
{
    xmlhttp = new XMLHttpRequest();
    if(xmlhttp)
    {
        url = "http://teletekst.nos.nl/gif/images/" + pagina + "-" + sub + ".gif?" + (new Date).getTime(); //we need this because of some kind of caching issue with Dashboard
        xmlhttp.open("GET", url, true);
        xmlhttp.onreadystatechange = RSchangeSubPageTester;
        xmlhttp.send(null);
    }
}

function Open()
{
    page     = document.getElementById('pagina').value;
    subPage  = document.getElementById('sub').value;
    Go(page, subPage, RSchange);
    
    if(new Number(subPage) > 1) genericButtonSetEnabled(btnPreviousSub, true);
    else genericButtonSetEnabled(btnPreviousSub, false);
}

function NextPage()
{
    if(page < 899) page++;
    else page = 100;
    subPage = "01";
    Go(page, subPage, RSchangeUp);
    genericButtonSetEnabled(btnPreviousSub, false);
}

function NextSub()
{
    subPage = GetSubPage(subPage, true);
    Go(page, subPage, RSchange);
    genericButtonSetEnabled(btnPreviousSub, true);
}

function PrevPage()
{
    if(page > 100) page--;
    else page = 899;
    subPage = "01";
    Go(page, subPage, RSchangeDown);
    genericButtonSetEnabled(btnPreviousSub, false);
}

function PrevSub()
{
    subPage = GetSubPage(subPage, false);
    Go(page, subPage, RSchange);
    genericButtonSetEnabled(btnNextSub, true);
    
    if(new Number(subPage) > 1) genericButtonSetEnabled(btnPreviousSub, true);
    else genericButtonSetEnabled(btnPreviousSub, false);
}

function GetSubPage(sub, goingUp)
{
    i = new Number(sub);
    if(goingUp) i++;
    else i--;
    
    if(i < 10) return new String("0" + i);
    else return new String(i);
}

function KeyDownHandler()
{
    if(event.keyCode == 13)
    {
        Open();
    }
}

function onload()
{
    document.captureEvents(Event.KEYDOWN);
    document.onkeydown = KeyDownHandler;
    Open();
    return true;
}

function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function hideBack()
{   
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    back.style.display="none";
    document.getElementById('fliprollie').style.display = 'none';
    front.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit (event)
{
    if (flipShown)
    {
        // fade in the info button
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}